﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace Project
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string sFilename = "";
            int sv = 0;

            // Get Filename
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "WavDatei|*.wav";
            openFileDialog1.Title = "open";
            openFileDialog1.ShowDialog();
            sFilename = openFileDialog1.FileName;

            
            if (sFilename != "")
            {
                // Read File
                FileStream fsSource = new FileStream(sFilename, FileMode.Open, FileAccess.Read);
                byte[] bytes = new byte[fsSource.Length];
                int numBytesToRead = (int)fsSource.Length;
                int numBytesRead = 0;
                while (numBytesToRead > 0)
                {
                    // Read may return anything from 0 to numBytesToRead.
                    int n = fsSource.Read(bytes, numBytesRead, numBytesToRead);

                    // Break when the end of the file is reached.
                    if (n == 0)
                        break;

                    numBytesRead += n;
                    numBytesToRead -= n;
                }
                fsSource.Close();

                // Erzeuge Array
                richTextBox1.Clear();
                richTextBox1.AppendText("#define SAMPLES " + (bytes.Length-44).ToString() + "\n");
                richTextBox1.AppendText("#define SAMPLE_RATE " + (bytes[24] + (bytes[25] << 8) + (bytes[26] << 16) + (bytes[27] << 32)).ToString() + "\n");
                richTextBox1.AppendText("extern const uint8_t data[SAMPLES] = {\n");

                for (sv = 44; sv < bytes.Length; sv++)
                {
                    richTextBox1.AppendText(bytes[sv].ToString());

                    if (sv < bytes.Length - 1)
                    {
                        richTextBox1.AppendText(", ");
                    }

                    if ((sv - 43) % 8 == 0)
                    {
                        richTextBox1.AppendText("\n");
                    }
                }
                richTextBox1.AppendText("};");
            } 
        }

        private void richTextBox1_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectAll();
        }
    }
}
